﻿
'===========================================================================
'Assembly: A managed dll or exe (built by .NET)
'Namespace: A group of managed types (classes, enums, structs, etc).

'One assembly can contain several namespaces. 
'One namespace can contain types from different assemblies.

'The name of the namespace is not necessarily the name of the assembly. 
'===========================================================================



' GetTypesInNamespace
'==================================================================================================


'Private Function GetTypesInNamespace(ByVal assembly As Assembly, ByVal nameSpace As String) As Type()
'   Return assembly.GetTypes.Where(t=, Greater, String.Equals(t.Namespace, nameSpace, StringComparison.Ordinal)).ToArray
'End Function

'Dim typelist() As Type = GetTypesInNamespace(Assembly.GetExecutingAssembly, "MyNamespace")
'Dim i As Integer = 0
'Do While (i < typelist.Length)
'    Console.WriteLine(typelist(i).Name)
'    i = (i + 1)
'Loop




' GetTypesInNamespace
'==================================================================================================
'myAssembly.ManifestModule.FindTypes()







' Enumerating all of the namespaces and their respective classes in an assembly (dll). 
'==================================================================================================
'     Dictionary<string, List<string> colNamespaces = New Dictionary<string, List<string>()

'      Assembly assembly = Assembly.GetAssembly(Type.GetType("Test2.Facade.ConcreteFacade,Test2"))
'      Type() theTypes = assembly.GetTypes()
'Dim t As Type
'      For Each t In theTypes
'            String theNameSpace = t.FullName.Substring(0,t.FullName.LastIndexOf("."))
'            String theClass = t.FullName.Substring(t.FullName.LastIndexOf(".")+1)

'            If colNamespaces.ContainsKey(theNameSpace) Then
'                colNamespaces(theNameSpace).Add(theClass)
'            Else 
'                List<string> classes = New List<string>()
'                classes.Add(theClass)
'                colNamespaces(theNameSpace) = classes
'            End If
'      Next





' NAMESPACES
'=====================================================================================

'System: Includes essential classes and base classes for commonly used data types, events, exceptions and so on
'System.Collections: Includes classes and interfaces that define various collection of objects such as list, queues, 
'hash tables, arrays, etc
'System.Data: Includes classes which lets us handle data from data sources
'System.Data.OleDb: Includes classes that support the OLEDB .NET provider
'System.Data.SqlClient: Includes classes that support the SQL Server .NET provider
'System.Diagnostics: Includes classes that allow to debug our application and to step through our code
'System.Drawing: Provides access to drawing methods
'System.Globalization: Includes classes that specify culture-related information
'System.IO: Includes classes for data access with Files
'System.Net: Provides interface to protocols used on the internet
'System.Reflection: Includes classes and interfaces that return information about types, methods and fields
'System.Security: Includes classes to support the structure of common language runtime security system
'System.Threading: Includes classes and interfaces to support multithreaded applications
'System.Web: Includes classes and interfaces that support browser-server communication
'System.Web.Services: Includes classes that let us build and use Web Services
'System.Windows.Forms: Includes classes for creating Windows based forms
'System.XML: Includes classes for XML support 
'=====================================================================================







' ================================================================================================================
'   CALLING ENTRY POINT WITH : DynamicFunctionDelegate
'
'     so we can execute strongly typed and without boxing 
' ================================================================================================================

'If Compiler_ErrorCount = 0 Then
'    Main = Nothing
'Dim DynamicClass As Type = Compiler_Results.CompiledAssembly.GetType("Script")
'    If DynamicClass IsNot Nothing Then
'Dim DynamicFunction As Reflection.MethodInfo = DynamicClass.GetMethod("Main", _
'                                                                      Reflection.BindingFlags.Public Or _
'                                                                      Reflection.BindingFlags.Static)
'        If DynamicFunction IsNot Nothing Then
'            Try
'                Main = CType([Delegate].CreateDelegate(GetType(Main_Delegate), Nothing, DynamicFunction), Main_Delegate)
'            Catch ex As Exception
'                Editor_ShowLinkerError(" ""Script Main""  " & ex.Message)
'            End Try
'        Else
'            Editor_ShowLinkerError(" ""Script Main"" not found.")
'        End If
'    Else
'        Editor_ShowLinkerError(" Class ""Script"" not found.")
'    End If
'End If

'    ' --------------------------------------------- this delegate must match the signature in SourceCode() above
'    Private Delegate Sub Main_Delegate(ByVal args() As String)
'    Dim Main As Main_Delegate

'    Friend Sub Compiler_CallMain(ByVal CsvArgsString As String)
'        '
'        ' ----------------------------------------------------------- if CsvArgsString=nothing then args=nothing 
'        Dim args() As String = Nothing
'        If CsvArgsString IsNot Nothing Then args = Split(CsvArgsString, ",")
'        '
'        If Main Is Nothing Then
'            Beep()
'            Exit Sub
'        End If
'        '
'        Try
'            Main(args)
'        Catch ex As Exception
'            Editor_ShowRuntimeError(ex.ToString)
'        End Try
'        '
'End Sub


' ================================================================================================================
'   CALLING ENTRY POINT WITH : "Invoke"
' ================================================================================================================
'' -------------------------------------------------------------------------------------
'Friend Sub Compiler_RunInMemory(ByVal CsvArgsString As String)
'    '
'    ' ----------------------------------------------------------- if CsvArgsString=nothing then args=nothing 
'    Dim args() As String = Nothing
'    If CsvArgsString IsNot Nothing Then args = Split(CsvArgsString, ",")

'    If Compiler_ErrorCount > 0 Then
'        Beep()
'        Exit Sub
'    End If

'    ' -------------------------------------------------------------------------------------
'    '  using "Invoke"
'    ' -------------------------------------------------------------------------------------
'    Try
'        Dim obj(0) As Object
'        obj(0) = args
'        Compiler_Results.CompiledAssembly.EntryPoint.Invoke(Nothing, obj)
'    Catch ex As Exception
'        Editor_ShowRuntimeError(ex.ToString)
'    End Try

'End Sub






' ================================================================================================================
'    Choose valid assemblyes
' ================================================================================================================

'Private Function IsValidAssembly(ByVal name As String) As Boolean
'    Select Case name
'        ' ------------------------------------------------------------------------------ required
'        Case "System.dll" : Return True
'        Case "System.Windows.Forms.dll" : Return True
'        Case "System.Drawing.dll" : Return True

'            ' -------------------------------------------------------------------------- useful
'        Case "System.Data.dll" : Return False
'        Case "System.Runtime.Remoting.dll" : Return False
'        Case "System.Configuration.dll" : Return False

'            ' -------------------------------------------------------------------------- to test
'        Case "ScriptingTest.exe" : Return False
'        Case "ScriptingTest.vshost.exe" : Return False
'        Case "Microsoft.VisualStudio.HostingProcess.Utilities.dll" : Return False
'        Case "Microsoft.VisualStudio.HostingProcess.Utilities.Sync.dll" : Return False
'        Case "Microsoft.VisualStudio.Debugger.Runtime.dll" : Return False
'        Case "System.Deployment.dll" : Return False
'        Case "System.Xml.dll" : Return False
'        Case "System.Xml.Linq.dll" : Return False

'            ' -------------------------------------------------------------------------- already present
'        Case "Microsoft.VisualBasic.dll" : Return False
'        Case "mscorlib.dll" : Return False
'        Case "mscorlib.dll" : Return False

'            ' -------------------------------------------------------------------------- not useful
'        Case "System.Core.dll" : Return False
'        Case "System.Data.DataSetExtensions.dll" : Return False
'        Case "System.Windows.Forms.resources.dll" : Return False
'    End Select
'End Function