
using System;  
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Theremino_Script;
  
  
partial class Script  
  
{  
	const uint LVM_FIRST = 0x1000;  
	const uint LVM_GETITEMCOUNT = (LVM_FIRST + 4);  
	const uint LVM_GETITEMPOSITION = (LVM_FIRST + 16);  

	[DllImport("user32.dll", SetLastError = true)]  
	public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);  
	
	[DllImport("user32.dll", SetLastError = true)]  
	public static extern IntPtr FindWindowEx(IntPtr parentHandle, IntPtr childAfter, string className, string windowTitle);  
	
	[DllImport("user32.dll", CharSet=CharSet.Auto)]  
	public static extern int SendMessage(IntPtr hWnd, uint Msg, int wParam, IntPtr lParam);  
	
	[DllImport("user32.dll", CharSet=CharSet.Auto)]  
	public static extern int SendMessage(IntPtr hWnd, uint Msg, int wParam, ref IntPtr lParam);  
	
	[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Ansi)]  
	public struct POINT  
	{  
		public long x;  
		public long y;  
	}  
	
	[STAThread]
	public static void Main(string[] args)
	{  
		IntPtr handle = FindWindow("progman", null);  
		
		handle = FindWindowEx(handle, IntPtr.Zero, "shelldll_defview", null);  
		
		handle = FindWindowEx(handle, IntPtr.Zero, "syslistview32", null);  
		
		// Get the Number of Icons  
		
		int iconCount = SendMessage(handle,  
		
		LVM_GETITEMCOUNT, 0, IntPtr.Zero);  
		
		Print("Number of Icons:  " + iconCount.ToString());  
		

		// Get Icon Positions 
		for (int i = 0; i < iconCount; i++)
		{ 
			POINT p;  
			p.x = 0;  
			p.y = 0;  
		
			IntPtr ptr = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(POINT)));  
		
			Marshal.StructureToPtr(p, ptr, true);  
		
			SendMessage(handle, LVM_GETITEMPOSITION, i, ref ptr);  
		
			p = (POINT)Marshal.PtrToStructure(ptr, typeof(POINT));  
		
			Print("Icon pos: (x = " + p.x.ToString() + ", y = " + p.y.ToString() + ")");  
			
			Marshal.FreeHGlobal(ptr);  
		}
	}  
	
	static void Print(string s)
	{
		Theremino_Script.Host.GetTextBox.Text += s + "\r\n";
	}
}
