
Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Web
Imports System.Configuration
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Generic
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports Theremino_Script

<Assembly: AssemblyTitle("ScriptingTest")>
<Assembly: AssemblyDescription("")>
<Assembly: AssemblyCompany("")>
<Assembly: AssemblyProduct("NetScript - Test")>
<Assembly: AssemblyCopyright("Copyright © xxx xxx")>
<Assembly: AssemblyTrademark("")>
<Assembly: ComVisible(False)>
<Assembly: Guid("ff17d595-7720-42c5-99a4-e1fe5dd91f92")>
<Assembly: AssemblyVersion("1.0.0.0")>
<Assembly: AssemblyFileVersion("1.0.0.0")>

Public Class Script
	Public Shared Sub Main(ByVal s() As String)
		'GetReferencedAssemblies_Info
		
		host.gettextbox.text = ""
		For Each ASM As Assembly In AppDomain.CurrentDomain.GetAssemblies()
			If ASM.Location <> "" Then
				
				' ------------------------------------------------------------ assemblies
				host.gettextbox.text &= ASM.FullName & vbcrlf
			
				' ------------------------------------------------------------ modules
				For Each m As [Module] In ASM.GetModules(True)
					host.gettextbox.text &= "  " & m.Name & vbcrlf
				Next
				
				' ------------------------------------------------------------ types
				For Each t as Type In ASM.GetExportedTypes()
					host.gettextbox.text &= "    " & t.tostring & vbcrlf
					
					' -------------------------------------------------------- members
					For Each mi as MemberInfo In t.GetMembers()
						host.gettextbox.text &= "      " & mi.name & vbcrlf
					Next
				Next
				
				
			End If
		
		Next
	End Sub
End Class




'http://msdn.microsoft.com/en-us/library/system.reflection.assembly.getreferencedassemblies.aspx

Module Module1

	Sub GetReferencedAssemblies_Info()
		' This variable holds the amount of indenting that 
		' should be used when displaying each line of information.
		Dim indent As Int32 = 0
		' Display information about the EXE assembly.
		Dim a As [Assembly] = System.Reflection.Assembly.GetExecutingAssembly()
		Display(indent, "Assembly identity={0}", a.FullName)
		Display(indent + 1, "Codebase={0}", a.CodeBase)

		' Display the set of assemblies our assemblies references.
		Dim an As AssemblyName
		Display(indent, "Referenced assemblies:")
		For Each an In a.GetReferencedAssemblies()
			Display(indent + 1, "Name={0}, Version={1}, Culture={2}, PublicKey token={3}", _
				an.Name, an.Version, an.CultureInfo.Name, BitConverter.ToString(an.GetPublicKeyToken))
		Next
		Display(indent, "")
		

		' Display information about each assembly loading into this AppDomain.
		For Each a In AppDomain.CurrentDomain.GetAssemblies()
			Display(indent, "Assembly: {0}", a)



			' Display information about each module of this assembly.
			Dim m As [Module]
			For Each m In a.GetModules(True)
				Display(indent + 1, "Module: {0}", m.Name)
			Next

			' Display information about each type exported from this assembly.
			Dim t As Type
			indent += 1
			For Each t In a.GetExportedTypes()
				Display(0, "")
				Display(indent, "Type: {0}", t)

		'		' For each type, show its members & their custom attributes.
				Dim mi As MemberInfo
				indent += 1
				For Each mi In t.GetMembers()
					Display(indent, "Member: {0}", mi.Name)
					DisplayAttributes(indent, mi)

		'			' If the member is a method, display information about its parameters.
					Dim pi As ParameterInfo
					If mi.MemberType = MemberTypes.Method Then
						For Each pi In CType(mi, MethodInfo).GetParameters()
							Display(indent + 1, "Parameter: Type={0}, Name={1}", pi.ParameterType, pi.Name)
						Next
					End If

		'			' If the member is a property, display information about the property's accessor methods.
					If mi.MemberType = MemberTypes.Property Then
						Dim am As MethodInfo
						For Each am In CType(mi, PropertyInfo).GetAccessors()
							Display(indent + 1, "Accessor method: {0}", am)
						Next
					End If
				Next
				indent -= 1
			Next
			indent -= 1
			
			
			
		Next
	End Sub

	' Displays the custom attributes applied to the specified member.
	Sub DisplayAttributes(ByVal indent As Int32, ByVal mi As MemberInfo)
		' Get the set of custom attributes; if none exist, just return.
		Dim attrs() As Object = mi.GetCustomAttributes(False)
		If attrs.Length = 0 Then Return

		' Display the custom attributes applied to this member.
		Display(indent + 1, "Attributes:")
		Dim o As Object
		For Each o In attrs
			Display(indent + 2, "{0}", o.ToString())
		Next
	End Sub

	' Display a formatted string indented by the specified amount.
	Sub Display(ByVal indent As Int32, ByVal format As String, ByVal ParamArray params() As Object)
		'Console.Write(New String(" "c, indent * 2))
		'Console.WriteLine(format, params)
		'debug.print(params.tostring)
		'beep
		if params.length > 0 then
			host.gettextbox.text &= params(0).tostring & vbcrlf
		end if
	End Sub
End Module

