
' ================================================================================================
'  Theremino System - Risonance frequency for a Loop Antenna made with shielded cable
' ================================================================================================

Dim CableLengthCm As Double
Dim PicoFaradPerMeter As Double = 100
Dim CoilDiameterCm As Double = 12.7
Dim CoilLengthCm As Double = 6
Dim CoilThicknessCm As Double = .2
Dim ntourns As Double = 15

Sub AppStart() 
	CableLengthCm = ntourns * (CoilDiameterCm * PI) / 100
	label1.text &= CableLengthCm & vbcrlf
	label1.text &= ntourns & vbcrlf
	label1.text &= InductanceMicroHenry(ntourns, CoilDiameterCm, CoilThicknessCm, CoilLengthCm) & vbcrlf
End Sub

Function InductanceMicroHenry(n As Double, diamCm As Double, thickCm As Double, lenCm As Double) As Double
	
	' ------------------------------------------------------------------ method 1
	'Dim MeanRadius As Double = diamCm / 2 + thickCm / 2
	'InductanceMicroHenry = 0.315 * ntourns^2 * MeanRadius^2 / (9 * lenCm + 10 * thickCm + 6 * MeanRadius)
	
	' ------------------------------------------------------------------ method 2
	InductanceMicroHenry = Induc_uH(ntourns, diamcm*10, thickcm*10, lencm*10)
End Function



' --------------------------------------------------------------------------------------------
' Inductance calculation from my old program "bobine"
' -------------------------------------------------------------------------------------------- 
Function Induc_uH(nt As Double, dmm As Double, thickmm As Double, lenmm As Double) As Double
	Dim old As Double
	Dim uH As Double
	If (dmm + lenmm + thickmm) <> 0 Then
		For f As Int32 = 1 To 100
			Calc_k(dmm, thickmm, lenmm)
			If K1 * dmm + K2 * lenmm + K3 * thickmm <> 0 Then
				old = uH
				uH = (dmm + thickmm) ^ 2 * nt ^ 2 / (K1 * dmm + K2 * lenmm + K3 * thickmm)
			End If
			If uH <= 0 Then f = 999: Exit For
			If Abs(old / uH - 1) < 0.0000001 Then Exit For
		Next
	End If
	Return uH
End Function

Dim K1 As Double
Dim K2 As Double
Dim K3 As Double
Dim K1o As Double = 353.969151
Dim K2o As Double = 904.708678
Dim K3o As Double = 1446.85356
Dim KK1 As Double = 0.0537771003
Dim KK2 As Double = -0.612893145
Dim KK3 As Double = 0.157202181

Sub Calc_k(diammm As Double, lenmm As Double, thickmm As Double)
	On Error Resume Next
	K1 = K1o * (1 + KK1 * ((lenmm + thickmm) / (lenmm + thickmm + diammm) - 1))
	K2 = K2o * (1 + KK2 * ((lenmm + thickmm) / (lenmm + thickmm + diammm) - 1))
	K3 = K3o * (1 + KK3 * ((lenmm + thickmm) / (lenmm + thickmm + diammm) - 1))
End Sub


' ------------------------------------------------------------------------------------------------
'  Main
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_load(sender As Object, e As System.EventArgs) Handles Form1.load
	AppStart
End Sub


' ---------------------------------------------------------------------- User Interface Components
Dim WithEvents Form1 As Form
Dim Label1 As Label = New Label
Dim WithEvents Button1 As Button = New Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Loop Antenna Resonance"
	Form1.ClientSize = New System.Drawing.Size(520, 600)
	Form1.StartPosition = FormStartPosition.CenterScreen
	Form1.FormBorderStyle = FormBorderStyle.Sizable
	Form1.MaximizeBox = False
	Form1.KeyPreview = True
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(8, 8)
	Label1.Width = form1.clientsize.Width-16
	Label1.Height = form1.clientsize.Height-16
	Label1.Font = New Font("Courier New", 10 )
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.right Or AnchorStyles.bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.Show
End Sub






