' ================================================================================================
' - ENGLISH - PULSE COUNTER
' ================================================================================================
'  This script counts the pulses in the specified slot
' ------------------------------------------------------------------------------------------------

' ================================================================================================
' - ITALIANO - CONTATORE DI IMPULSI
' ================================================================================================
'  Questo conta gli impulsi sullo slot specificato
' ------------------------------------------------------------------------------------------------

Const InputSlot As Int32 = 1



' ================================================================================================
'   COUNTER
' ================================================================================================
Dim Counter As Int32
Dim OldValue As Int32 = -1
Dim NewValue As Int32
Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	NewValue = CInt(ReadSlot(InputSlot))
	If OldValue < 0 Then
		ResetCounter
	End If
	If NewValue >= OldValue Then
		Counter += NewValue - OldValue
	Else
		Counter += (65535 - OldValue) + NewValue + 1
	End If
	OldValue = NewValue
	Label1.Text = Counter.ToString("0")
End Sub

Sub ResetCounter()
	OldValue = NewValue
	Counter = 0
End Sub

Sub ButtonReset_MouseDown(sender As Object, e As MouseEventArgs) Handles ButtonReset.MouseDown
	ResetCounter
End Sub


' ================================================================================================
'   Program Start and Close
' ================================================================================================
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New Form
	InitializeComponents
	MemoryMappedFile_Init
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
End Sub


' ================================================================================================
'   User Interface Components
' ================================================================================================
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim Label1 As Label = New Label
Dim WithEvents ButtonReset As System.Windows.Forms.Button = New System.Windows.Forms.Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Pulse Counter"
	Form1.FormBorderStyle = FormBorderStyle.Fixed3D
	Form1.MaximizeBox = False
	Form1.ClientSize = New System.Drawing.Size(350, 84)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Button Reset
	ButtonReset.Text = "Reset"
	ButtonReset.FlatStyle = FlatStyle.System
	ButtonReset.Font = New Font("Arial", 8)
	ButtonReset.Location = New Point(-1, 69)
	ButtonReset.Size = New Size(45, 16)
	Form1.Controls.Add(ButtonReset)
	' ------------------------------------------------------------------ Label 1
	'Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(0, 0)
	Label1.Size = Form1.ClientSize
	Label1.BackColor = Color.DarkBlue
	Label1.ForeColor = Color.Gold
	Label1.Font = New Font("Tahoma", 55, FontStyle.Bold)
	Label1.TextAlign = ContentAlignment.MiddleRight
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or _
					AnchorStyles.Right Or AnchorStyles.Bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 15
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.Show
End Sub
